// SfCsSys.c : STARFAX VXemF֐
//

#include	"windows.h"

#include	"SfCsSys.h"

/////////////////////////////////////////////////////////////////////////////
// 萔`

/////////////////////////////////////////////////////////////////////////////
// }N`

// (S-JIS)̂PoCgځH
#define	CheckDBS(c) ((0x80<=((unsigned char)c)&&((unsigned char)c)<=0x9f)||(0xe0<=((unsigned char)c)&&((unsigned char)c)<=0xfe))

/////////////////////////////////////////////////////////////////////////////
// ֐

	// WXgpX擾 (Ō'\\')
static DWORD APIENTRY	SUB_GetSvcRegPathString( char *pKey, char *pDefault, char *pGet, DWORD dwBufLen );
	// ֘AC^[tFCXtH_̃t@C쐬
static void APIENTRY	SUB_GetCtrlFolderFile( char *pName  );
	// tH_݊mF
static BOOL APIENTRY	SUB_CheckExistFolder( char *pFolder );
	// t@C݊mF
static BOOL APIENTRY	SUB_CheckExistFile( char *pFileName );
	// T[rXmF
static BOOL APIENTRY	FUNC_IsServiceRunning( void );

//**********************************************************************
// ֐        : SFCSSYS_CheckInstall
// @\          : STARFAX CXg[mF
// Ăяo      : int APIENTRY SFCSSYS_CheckInstall( void )
//           : Ȃ
// o          : Ԓl  G[R[h
//               : 
//               :         SFCS_SUCCESS          ... I
//               :         SFCS_ERR_NoRegInstall ... CXg[tH_WXgɐݒ肳Ă܂B
//               :         SFCS_ERR_NoInstall    ... CXg[tH_݂܂B
//               :         SFCS_ERR_NoRegCtrl    ... ֘AC^[tFCXtH_WXgɐݒ肳Ă܂B
//               :         SFCS_ERR_NoCtrl       ... ֘AC^[tFCXtH_݂܂B
//               :         SFCS_ERR_NoRegData    ... f[^tH_WXgɐݒ肳Ă܂B
//               :         SFCS_ERR_NoData       ... f[^tH_݂܂B
//               : 
// L      :   STARFAX ̃CXg[󋵂̊mF܂B
// 쐬        : 
// 쐬        : 2005.07.27
//**********************************************************************
int APIENTRY	SFCSSYS_CheckInstall()
{
	int	iRet = SFCS_SUCCESS;	// l͐

	char	szInstll[MAX_PATH+1];
	char	szCtrl[MAX_PATH+1];
	char	szData[MAX_PATH+1];

	// CXg[tH_`FbN

	if( !SFCSSYS_GetSfcsFolder( szInstll, MAX_PATH + 1 ) ) {
		iRet = SFCS_ERR_NoRegInstall;
		goto	EXIT;
	}
	if( !SUB_CheckExistFolder( szInstll ) ) {
		iRet = SFCS_ERR_NoInstall;
		goto	EXIT;
	}

	// ֘AC^[tFCXtH_`FbN

	if( !SFCSSYS_GetCtrlFolder( szCtrl, MAX_PATH + 1 ) ) {
		iRet = SFCS_ERR_NoRegCtrl;
		goto	EXIT;
	}
	if( !SUB_CheckExistFolder( szCtrl ) ) {
		iRet = SFCS_ERR_NoCtrl;
		goto	EXIT;
	}

	// f[^tH_`FbN

	if( !SFCSSYS_GetDataFolder( szData, MAX_PATH + 1 ) ) {
		iRet = SFCS_ERR_NoRegData;
		goto	EXIT;
	}
	if( !SUB_CheckExistFolder( szData ) ) {
		iRet = SFCS_ERR_NoData;
		goto	EXIT;
	}

EXIT:

	return iRet;
}

//**********************************************************************
// ֐        : SFCSSYS_CheckSubFolder
// @\          : STARFAX TutH_mF
// Ăяo      : int APIENTRY SFCSSYS_CheckSubFolder( int iMode )
//           : iMode = TutH_[h
// o          : Ԓl  G[R[h
//               : 
//               :         SFCS_SUCCESS        ... I
//               :         SFCS_ERR_NoRegCtrl  ... ֘AC^[tFCXtH_WXgɐݒ肳Ă܂B
//               :         SFCS_ERR_NoCtrl     ... ֘AC^[tFCXtH_݂܂B
//               :         SFCS_ERR_NoFolder   ... tH_݂܂B
//               :         SFCS_ERR_PARAM_MODE ... ֐G[: TutH_[h̎wɌ肪܂B
//               : 
// L      :   STARFAX ̊eTutH_̑݊mF܂B
// 쐬        : 
// 쐬        : 2005.07.27
//**********************************************************************
int APIENTRY	SFCSSYS_CheckSubFolder( int iMode )
{
	int	iRet = SFCS_SUCCESS;	// l͐

	char	szCtrl[MAX_PATH+1];
	char	szFolderRoot[(MAX_PATH+1)*2];
	char	szFolderSub[(MAX_PATH+1)*2];

	// ֘AC^[tFCXtH_`FbN

	if( !SFCSSYS_GetCtrlFolder( szCtrl, MAX_PATH + 1 ) ) {
		iRet = SFCS_ERR_NoRegCtrl;
		goto	EXIT;
	}
	if( !SUB_CheckExistFolder( szCtrl ) ) {
		iRet = SFCS_ERR_NoCtrl;
		goto	EXIT;
	}

	switch( iMode ) {

	case	SFCS_SMODE_SENDMIS:		// M߃tH_mF
		wsprintf( szFolderRoot, "%s\\%s", szCtrl, SFCS_FLD_SENDMIS );
		if( !SUB_CheckExistFolder( szFolderRoot ) ) {
			iRet = SFCS_ERR_NoFolder;
			goto	EXIT;
		}
		break;

	case	SFCS_SMODE_RECVINFO:		// MtH_mF
		wsprintf( szFolderRoot, "%s\\%s", szCtrl, SFCS_FLD_RECVINFO );
		if( !SUB_CheckExistFolder( szFolderRoot ) ) {
			iRet = SFCS_ERR_NoFolder;
			goto	EXIT;
		}
		break;

	case	SFCS_SMODE_RECVDELMIS:		// M폜߃tH_mF
		wsprintf( szFolderRoot, "%s\\%s", szCtrl, SFCS_FLD_RECVINFO );
		lstrcpy( szFolderSub, szFolderRoot );
		lstrcat( szFolderSub, "\\" );
		lstrcat( szFolderSub, SFCS_FLD_RECVDELMIS );
		if( !SUB_CheckExistFolder( szFolderSub ) ) {
			iRet = SFCS_ERR_NoFolder;
			goto	EXIT;
		}
		break;

	case	SFCS_SMODE_SENDINFO:		// MtH_mF
		wsprintf( szFolderRoot, "%s\\%s", szCtrl, SFCS_FLD_SENDINFO );
		if( !SUB_CheckExistFolder( szFolderRoot ) ) {
			iRet = SFCS_ERR_NoFolder;
			goto	EXIT;
		}
		break;

	case	SFCS_SMODE_SENDDELMIS:		// M폜߃tH_mF
		wsprintf( szFolderRoot, "%s\\%s", szCtrl, SFCS_FLD_SENDINFO );
		lstrcpy( szFolderSub, szFolderRoot );
		lstrcat( szFolderSub, "\\" );
		lstrcat( szFolderSub, SFCS_FLD_SENDDELMIS );
		if( !SUB_CheckExistFolder( szFolderSub ) ) {
			iRet = SFCS_ERR_NoFolder;
			goto	EXIT;
		}
		break;

	case	SFCS_SMODE_QUEINFO:		// MtH_mF
		wsprintf( szFolderRoot, "%s\\%s", szCtrl, SFCS_FLD_QUEINFO );
		if( !SUB_CheckExistFolder( szFolderRoot ) ) {
			iRet = SFCS_ERR_NoFolder;
			goto	EXIT;
		}
		break;

	case	SFCS_SMODE_QUEDELMIS:		// M폜߃tH_mF
		wsprintf( szFolderRoot, "%s\\%s", szCtrl, SFCS_FLD_QUEINFO );
		lstrcpy( szFolderSub, szFolderRoot );
		lstrcat( szFolderSub, "\\" );
		lstrcat( szFolderSub, SFCS_FLD_QUEDELMIS );
		if( !SUB_CheckExistFolder( szFolderSub ) ) {
			iRet = SFCS_ERR_NoFolder;
			goto	EXIT;
		}
		break;

	case	SFCS_SMODE_PRTMIS:		// ߃tH_mF
		wsprintf( szFolderRoot, "%s\\%s", szCtrl, SFCS_FLD_PRTMIS );
		if( !SUB_CheckExistFolder( szFolderRoot ) ) {
			iRet = SFCS_ERR_NoFolder;
			goto	EXIT;
		}
		break;

	case	SFCS_SMODE_EMSMIS:		// [M߃tH_mF
		wsprintf( szFolderRoot, "%s\\%s", szCtrl, SFCS_FLD_EMSMIS );
		if( !SUB_CheckExistFolder( szFolderRoot ) ) {
			iRet = SFCS_ERR_NoFolder;
			goto	EXIT;
		}
		break;

	case	SFCS_SMODE_RECVADDNOTI:		// MǉςݒʒmtH_mF
		wsprintf( szFolderRoot, "%s\\%s", szCtrl, SFCS_FLD_NOTIINFO );
		lstrcpy( szFolderSub, szFolderRoot );
		lstrcat( szFolderSub, "\\" );
		lstrcat( szFolderSub, SFCS_FLD_RECVADDNOTI );
		if( !SUB_CheckExistFolder( szFolderSub ) ) {
			iRet = SFCS_ERR_NoFolder;
			goto	EXIT;
		}
		break;

	case	SFCS_SMODE_SENDADDNOTI:		// MǉςݒʒmtH_mF
		wsprintf( szFolderRoot, "%s\\%s", szCtrl, SFCS_FLD_NOTIINFO );
		lstrcpy( szFolderSub, szFolderRoot );
		lstrcat( szFolderSub, "\\" );
		lstrcat( szFolderSub, SFCS_FLD_SENDADDNOTI );
		if( !SUB_CheckExistFolder( szFolderSub ) ) {
			iRet = SFCS_ERR_NoFolder;
			goto	EXIT;
		}
		break;

	case	SFCS_SMODE_RECVDELNOTI:		// M폜ςݒʒmtH_mF
		wsprintf( szFolderRoot, "%s\\%s", szCtrl, SFCS_FLD_NOTIINFO );
		lstrcpy( szFolderSub, szFolderRoot );
		lstrcat( szFolderSub, "\\" );
		lstrcat( szFolderSub, SFCS_FLD_RECVDELNOTI );
		if( !SUB_CheckExistFolder( szFolderSub ) ) {
			iRet = SFCS_ERR_NoFolder;
			goto	EXIT;
		}
		break;

	case	SFCS_SMODE_SENDDELNOTI:		// M폜ςݒʒmtH_mF
		wsprintf( szFolderRoot, "%s\\%s", szCtrl, SFCS_FLD_NOTIINFO );
		lstrcpy( szFolderSub, szFolderRoot );
		lstrcat( szFolderSub, "\\" );
		lstrcat( szFolderSub, SFCS_FLD_SENDDELNOTI );
		if( !SUB_CheckExistFolder( szFolderSub ) ) {
			iRet = SFCS_ERR_NoFolder;
			goto	EXIT;
		}
		break;

	default:
		iRet = SFCS_ERR_PARAM_MODE;
		break;
	}
		
EXIT:

	return iRet;
}

//**********************************************************************
// ֐        : SFCSSYS_CheckServiceStatus
// @\          : STARFAX T[rXԎ擾
// Ăяo      : int APIENTRY SFCSSYS_CheckServiceStatus( void )
//           : Ȃ
// o          : Ԓl  T[rX
//               : 
//               :         SFCS_SERVICE_STOP    ... ~
//               :         SFCS_SERVICE_SERVICE ... T[rX[h쒆
//               :         SFCS_SERVICE_TRAY    ... T[rX[h 쒆
//               : 
// L      :   STARFAX ̃T[rX̏Ԃ擾܂B
// 쐬        : 
// 쐬        : 2005.07.27
//**********************************************************************
int APIENTRY	SFCSSYS_CheckServiceStatus( void )
{
	int	iRet = SFCS_SERVICE_STOP;

    if( GetVersion() & 0x80000000 ) {
		goto	STEP_TRAY;
	}

	if( FUNC_IsServiceRunning() ) {
		iRet = SFCS_SERVICE_SERVICE;
		goto	EXIT;
	}

STEP_TRAY:

	if( FindWindow( "SfCsCtlClass", NULL ) ) {
		iRet = SFCS_SERVICE_TRAY;
	}

EXIT:

	return iRet;
}

//**********************************************************************
// ֐        : SFCSSYS_GetSfcsFolder
// @\          : CXg[tH_pX擾 (Ō'\\')
// Ăяo      : DWORD APIENTRY SFCSSYS_GetSfcsFolder( char *pGet, DWORD dwBufLen )
//           : pGet     = 擾obt@
//               : dwBufLen = 擾obt@oCg
// o          : Ԓl  ̐
// L      : 
// 쐬        : 
// 쐬        : 2001.11.16
//**********************************************************************
DWORD APIENTRY	SFCSSYS_GetSfcsFolder( char *pGet, DWORD dwBufLen )
{
	DWORD	dwRet = 0;

	dwRet = SUB_GetSvcRegPathString( SFCS_KEY_INSTALL, "", pGet, dwBufLen );

	return dwRet;
}

//**********************************************************************
// ֐        : SFCSSYS_GetCtrlFolder
// @\          : ֘AC^[tFCXtH_pX擾 (Ō'\\')
// Ăяo      : DWORD APIENTRY SFCSSYS_GetCtrlFolder( char *pGet, DWORD dwBufLen )
//           : pGet     = 擾obt@
//               : dwBufLen = 擾obt@oCg
// o          : Ԓl  ̐
// L      : 
// 쐬        : 
// 쐬        : 2001.11.16
//**********************************************************************
DWORD APIENTRY	SFCSSYS_GetCtrlFolder( char *pGet, DWORD dwBufLen )
{
	DWORD	dwRet = 0;

	dwRet = SUB_GetSvcRegPathString( SFCS_KEY_CTRL, "", pGet, dwBufLen );

	return dwRet;
}

//**********************************************************************
// ֐        : SFCSSYS_GetDataFolder
// @\          : f[^tH_pX擾 (Ō'\\')
// Ăяo      : DWORD APIENTRY SFCSSYS_GetDataFolder( char *pGet, DWORD dwBufLen )
//           : pGet     = 擾obt@
//               : dwBufLen = 擾obt@oCg
// o          : Ԓl  ̐
// L      : 
// 쐬        : 
// 쐬        : 2001.11.16
//**********************************************************************
DWORD APIENTRY	SFCSSYS_GetDataFolder( char *pGet, DWORD dwBufLen )
{
	DWORD	dwRet = 0;

	dwRet = SUB_GetSvcRegPathString( SFCS_KEY_DATA, "", pGet, dwBufLen );

	return dwRet;
}

//**********************************************************************
// ֐        : SFCSSYS_GetSubFolder
// @\          : eTutH_pX擾 (Ō'\\')
// Ăяo      : DWORD APIENTRY SFCSSYS_GetSubFolder( int iMode, char *pGet, DWORD dwBufLen )
//           : iMode    = TutH_[h
//               : pGet     = 擾obt@
//               : dwBufLen = 擾obt@oCg
// o          : Ԓl  ̐
// L      : 
// 쐬        : 
// 쐬        : 2002.05.14
//**********************************************************************
DWORD APIENTRY	SFCSSYS_GetSubFolder( int iMode, char *pGet, DWORD dwBufLen )
{
	DWORD	dwRet = 0;	// l͎s

	char	szCtrl[MAX_PATH+1];
	char	szFolderRoot[(MAX_PATH+1)*2];
	char	szFolderSub[(MAX_PATH+1)*2];

	// ֘AC^[tFCXtH_`FbN

	if( !SFCSSYS_GetCtrlFolder( szCtrl, MAX_PATH + 1 ) ) {
		goto	EXIT;
	}

	switch( iMode ) {

	case	SFCS_SMODE_SENDMIS:		// M߃tH_
		wsprintf( szFolderSub, "%s\\%s", szCtrl, SFCS_FLD_SENDMIS );
		break;

	case	SFCS_SMODE_RECVINFO:		// MtH_
		wsprintf( szFolderSub, "%s\\%s", szCtrl, SFCS_FLD_RECVINFO );
		break;

	case	SFCS_SMODE_RECVDELMIS:		// M폜߃tH_
		wsprintf( szFolderRoot, "%s\\%s", szCtrl, SFCS_FLD_RECVINFO );
		lstrcpy( szFolderSub, szFolderRoot );
		lstrcat( szFolderSub, "\\" );
		lstrcat( szFolderSub, SFCS_FLD_RECVDELMIS );
		break;

	case	SFCS_SMODE_SENDINFO:		// MtH_
		wsprintf( szFolderSub, "%s\\%s", szCtrl, SFCS_FLD_SENDINFO );
		break;

	case	SFCS_SMODE_SENDDELMIS:		// M폜߃tH_
		wsprintf( szFolderRoot, "%s\\%s", szCtrl, SFCS_FLD_SENDINFO );
		lstrcpy( szFolderSub, szFolderRoot );
		lstrcat( szFolderSub, "\\" );
		lstrcat( szFolderSub, SFCS_FLD_SENDDELMIS );
		break;

	case	SFCS_SMODE_QUEINFO:		// MtH_
		wsprintf( szFolderSub, "%s\\%s", szCtrl, SFCS_FLD_QUEINFO );
		break;

	case	SFCS_SMODE_QUEDELMIS:		// M폜߃tH_
		wsprintf( szFolderRoot, "%s\\%s", szCtrl, SFCS_FLD_QUEINFO );
		lstrcpy( szFolderSub, szFolderRoot );
		lstrcat( szFolderSub, "\\" );
		lstrcat( szFolderSub, SFCS_FLD_QUEDELMIS );
		break;

	case	SFCS_SMODE_PRTMIS:		// ߃tH_
		wsprintf( szFolderSub, "%s\\%s", szCtrl, SFCS_FLD_PRTMIS );
		break;

	case	SFCS_SMODE_EMSMIS:		// [M߃tH_
		wsprintf( szFolderSub, "%s\\%s", szCtrl, SFCS_FLD_EMSMIS );
		break;

	case	SFCS_SMODE_RECVADDNOTI:		// MǉςݒʒmtH_
		wsprintf( szFolderRoot, "%s\\%s", szCtrl, SFCS_FLD_NOTIINFO );
		lstrcpy( szFolderSub, szFolderRoot );
		lstrcat( szFolderSub, "\\" );
		lstrcat( szFolderSub, SFCS_FLD_RECVADDNOTI );
		break;

	case	SFCS_SMODE_SENDADDNOTI:		// MǉςݒʒmtH_
		wsprintf( szFolderRoot, "%s\\%s", szCtrl, SFCS_FLD_NOTIINFO );
		lstrcpy( szFolderSub, szFolderRoot );
		lstrcat( szFolderSub, "\\" );
		lstrcat( szFolderSub, SFCS_FLD_SENDADDNOTI );
		break;

	case	SFCS_SMODE_RECVDELNOTI:		// M폜ςݒʒmtH_
		wsprintf( szFolderRoot, "%s\\%s", szCtrl, SFCS_FLD_NOTIINFO );
		lstrcpy( szFolderSub, szFolderRoot );
		lstrcat( szFolderSub, "\\" );
		lstrcat( szFolderSub, SFCS_FLD_RECVDELNOTI );
		break;

	case	SFCS_SMODE_SENDDELNOTI:		// M폜ςݒʒmtH_
		wsprintf( szFolderRoot, "%s\\%s", szCtrl, SFCS_FLD_NOTIINFO );
		lstrcpy( szFolderSub, szFolderRoot );
		lstrcat( szFolderSub, "\\" );
		lstrcat( szFolderSub, SFCS_FLD_SENDDELNOTI );
		break;

	default:
		goto	EXIT;
		break;
	}

	if( lstrlen( szFolderSub ) < (int)dwBufLen ) {
		dwRet = lstrlen( szFolderSub );
		lstrcpy( pGet, szFolderSub );
	}
		
EXIT:

	return dwRet;
}

//**********************************************************************
// ֐        : SFCSSYS_GetRunInfoString
// @\          : N񕶎擾
// Ăяo      : DWORD APIENTRY SFCSSYS_GetRunInfoString( char *pSection, char *pKey, char *pDefault, char *pGet, DWORD dwBufLen )
//           : pSection = ZNV
//               : pKey     = L[
//               : pDefault = ftHg
//               : pGet     = 擾obt@
//               : dwBufLen = 擾obt@oCg
// o          : Ԓl  ̐
// L      : 
// 쐬        : 
// 쐬        : 2001.11.16
//**********************************************************************
DWORD APIENTRY	SFCSSYS_GetRunInfoString( char *pSection, char *pKey, char *pDefault, char *pGet, DWORD dwBufLen )
{
	DWORD	dwRet = 0;

	char	szIni[MAX_PATH+1];

	lstrcpy( szIni, SFCS_FILE_RUN );
	SUB_GetCtrlFolderFile( szIni );

	dwRet = GetPrivateProfileString( pSection, pKey, pDefault, pGet, dwBufLen, szIni );

	return dwRet;
}

//**********************************************************************
// ֐        : SFCSSYS_GetRunInfoInt
// @\          : NDWORD擾
// Ăяo      : DWORD APIENTRY SFCSSYS_GetRunInfoInt( char *pSection, char *pKey, DWORD dwDefault )
//           : pSection  = ZNV
//               : pKey      = L[
//               : dwDefault = ftHgl
// o          : Ԓl  l
// L      : 
// 쐬        : 
// 쐬        : 2001.11.16
//**********************************************************************
DWORD APIENTRY	SFCSSYS_GetRunInfoInt( char *pSection, char *pKey, DWORD dwDefault )
{
	DWORD	dwRet = 0;

	char	szIni[MAX_PATH+1];

	lstrcpy( szIni, SFCS_FILE_RUN );
	SUB_GetCtrlFolderFile( szIni );

	dwRet = GetPrivateProfileInt( pSection, pKey, dwDefault, szIni );

	return dwRet;
}

//**********************************************************************
// ֐        : 
// @\          : tAɂŗL̃t@C쐬
// Ăяo      : 
//           :      = 
// o          : Ԓl  
// L      : 
// 쐬        : 
// 쐬        : 2001.11.16
//**********************************************************************
BOOL APIENTRY	SFCSSYS_GetUniqFileName( char *pFolder, char *pWild, char *pMakePath )
{
	BOOL	bRet = FALSE;

	char	szTmp[MAX_PATH+1];
	char	szTmpArea[MAX_PATH+1];
	LCID	g_lcid;
	SYSTEMTIME	SysTime;	// VXeԍ\
	int	iLen;
	int	iOnceCnt = 0;

STEP_OnceMoreMake:

	ZeroMemory( szTmpArea, sizeof(szTmpArea) );
	g_lcid = GetUserDefaultLCID();	// P[̎擾
	GetLocalTime( &SysTime );
	GetDateFormat( g_lcid, DATE_SHORTDATE, &SysTime, NULL, szTmpArea, sizeof(szTmpArea) );
	iLen = lstrlen( szTmpArea );
	GetTimeFormat( g_lcid, TIME_FORCE24HOURFORMAT, &SysTime, NULL, &(szTmpArea[iLen]), sizeof(szTmpArea) - iLen );
	wsprintf( szTmp, pWild, SysTime.wYear, SysTime.wMonth, SysTime.wDay, SysTime.wHour, SysTime.wMinute, SysTime.wSecond, SysTime.wMilliseconds );

	lstrcpy( pMakePath, pFolder );
	lstrcat( pMakePath, "\\" );
	lstrcat( pMakePath, szTmp );

	if( SUB_CheckExistFile( pMakePath ) ) {
		iOnceCnt++;
		if( iOnceCnt < 100 ) {
			Sleep( 10 );
			goto	STEP_OnceMoreMake;
		}
	}
	else {
		bRet = TRUE;
	}

	return bRet;
}

/////////////////////////////////////////////////////////////////////////////
// ֐

//**********************************************************************
// ֐        : SUB_GetSvcRegPathString
// @\          : WXgpX擾 (Ō'\\')
// Ăяo      : DWORD APIENTRY SUB_GetSvcRegPathString( char *pKey, char *pDefault, char *pGet, DWORD dwBufLen )
//           : pKey     = L[
//               : pDefault = ftHg
//               : pGet     = 擾obt@
//               : dwBufLen = 擾obt@oCg
// o          : Ԓl  ̐
// L      : 
// 쐬        : 
// 쐬        : 2001.11.16
//**********************************************************************
static DWORD APIENTRY	SUB_GetSvcRegPathString( char *pKey, char *pDefault, char *pGet, DWORD dwBufLen )
{
	DWORD	dwRet = 0;

	HKEY	hKey = NULL; 
	DWORD	dwType;

	ZeroMemory( pGet, dwBufLen );
	if( ERROR_SUCCESS == RegOpenKeyEx( HKEY_LOCAL_MACHINE, SFCS_LMKEY_SFCS, 0, KEY_READ, &hKey ) ) {
		RegQueryValueEx( hKey, pKey, NULL, &dwType, (BYTE*)pGet, &dwBufLen );
		RegCloseKey( hKey );
		dwRet = lstrlen( pGet );
	}
	else {
		if( pDefault ) {
			lstrcpy( pGet, pDefault );
			dwRet = lstrlen( pGet );
		}
		goto	EXIT;
	}

	if( dwRet ) {

		// Ō'\\'  

		char	*pChk = pGet;
		char	*pEnd = pGet + lstrlen( pGet );

		for( ; pChk < pEnd ; pChk++ ) {
			if( *pChk == '\\' && ( pChk == ( pEnd  - 1 ) ) ) {
				*pChk = 0x00;
				dwRet--;
				break;
			}
			if( CheckDBS( *pChk ) ) {
				pChk++;
			}			
		}
	}

EXIT:

	return dwRet;
}

//**********************************************************************
// ֐        : SUB_GetCtrlFolderFile
// @\          : ֘AC^[tFCXtH_̃t@C쐬
// Ăяo      : void APIENTRY SUB_GetCtrlFolderFile( char *pName )
//           : Ȃ
// o          : Ԓl  Ȃ
// L      : 
// 쐬        : 
// 쐬        : 2001.11.16
//**********************************************************************
static void APIENTRY	SUB_GetCtrlFolderFile( char *pName  )
{
	char	szString[MAX_PATH+1];	// e|̊i[obt@
	char	szWork[MAX_PATH+1];	// e|̊i[obt@

	lstrcpy( szString, pName );

	if( !SFCSSYS_GetCtrlFolder( szWork, MAX_PATH + 1 ) ) {
		GetWindowsDirectory( szWork, MAX_PATH+1 );
	}

	lstrcpy( pName, szWork );
	lstrcat( pName, "\\" );
	lstrcat( pName, szString );
}

//**********************************************************************
// ֐        : 
// @\          : tH_݊mF
// Ăяo      : 
//           :      = 
// o          : Ԓl  
// L      : 
// 쐬        : 
// 쐬        : 2001.11.16
//**********************************************************************
static BOOL APIENTRY	SUB_CheckExistFolder( char *pFolder )
{
	BOOL	bRet = FALSE;	// l͎s

	WIN32_FIND_DATA	FileData; 
	HANDLE	hSearch; 

	hSearch = FindFirstFile( pFolder, &FileData ); 
	if( hSearch != INVALID_HANDLE_VALUE ) { 

		FindClose( hSearch );

		// t@C

		if( !( FileData.dwFileAttributes & FILE_ATTRIBUTE_DIRECTORY ) ) { 

			// tH_Ŗ

			goto	EXIT;
		}

		bRet = TRUE;
	} 

EXIT:

	return bRet;
}

//**********************************************************************
// ֐        : 
// @\          : t@C݊mF
// Ăяo      : 
//           :      = 
// o          : Ԓl  
// L      : 
// 쐬        : 
// 쐬        : 2001.11.16
//**********************************************************************
static BOOL APIENTRY	SUB_CheckExistFile( char *pFileName )
{
	BOOL	bRet = FALSE;	// l͎s

	WIN32_FIND_DATA	FileData; 
	HANDLE	hSearch; 

	hSearch = FindFirstFile( pFileName, &FileData ); 
	if( hSearch != INVALID_HANDLE_VALUE ) { 

		FindClose( hSearch );

		// t@C

		bRet = TRUE;
	} 

	return bRet;
}

//**********************************************************************
// ֐        : FUNC_IsServiceRunning
// @\          : T[rXmF
// Ăяo      : BOOL APIENTRY FUNC_IsServiceRunning( void )
//           : Ȃ
// o          : Ԓl  TRUE  = T[rX쒆
//               :       FALSE
// L      : 
// 쐬        : 
// 쐬        : 2005.06.24
//**********************************************************************
static BOOL APIENTRY	FUNC_IsServiceRunning( void )
{
	SC_HANDLE	hSCM = NULL;
	SC_HANDLE	hService = NULL;
	SERVICE_STATUS	status;
	BOOL	bRet = FALSE;

	char	szService[257] = "STARFAX Engine";
	char	szDisplay[257] = "MEGASOFT STARFAX Engine";

	// w肳ꂽ}ṼT[rX}l[Wւ̐ڑm 
	// w肳ꂽf[^x[XI[v܂B
	hSCM = OpenSCManager( NULL, NULL, SC_MANAGER_CONNECT );
	if( !hSCM ) {
		goto	EXIT;
	}
	
	// ̃T[rXʂnhI[v܂B
	hService = OpenService(
		hSCM,			// T[rX}l[W f[^x[X̃nh
		szService,		// NT[rX̖ÕAhX
		SERVICE_QUERY_STATUS );		// T[rX̃ANZX̎					
						// SERVICE_ALL_ACCESS :
						//   ̕\ŎĂ邷ׂẴANZX̎ނ̂قɤ 
						//   STANDARD_RIGHTS_REQUIRED܂݂܂B
						// SERVICE_CHANGE_CONFIG :
						//   ChangeServiceConfig֐ĂяoĤ T[rX\ύXł܂B
						// SERVICE_ENUMERATE_DEPENDENTS :
						//   EnumDependentServices֐ĂяoĤ ̃T[rX
						//   ˑT[rXׂė񋓂ł܂B
						// SERVICE_INTERROGATE :
						//   ControlService֐ĂяoĤ Ԃɕ񍐂悤
						//   T[rXɎwł܂B
						// SERVICE_PAUSE_CONTINUE :
						//   ControlService֐ĂяoĤ T[rXꎞ~܂͍ĊJł܂B
						// SERVICE_QUERY_CONFIG :
						//   QueryServiceConfig֐ĂяoĤ T[rX̍\
						//   ₢킹邱Ƃł܂B
						// SERVICE_QUERY_STATUS :
						//   QueryServiceStatus֐ĂяoĤ T[rX̏Ԃ
						//   T[rX}l[Wɖ₢킹邱Ƃł܂B
						// SERVICE_START :
						//   StartService֐ĂяoĤ T[rXNł܂B
						// SERVICE_STOP :
						//   ControlService֐ĂяoĤ T[rX~ł܂B
						// SERVICE_USER_DEFINE_CONTROL :
						//   ControlService֐ĂяoĤ [U[`̐R[hwł܂B
						// 
						// DELETE :
						//   DeleteService֐ĂяoĤ T[rX폜ł܂B
						// READ_CONTROL :
						//   QueryServiceObjectSecurity֐ĂяoĤ T[rX IuWFNg
						//   ZLeBLqq₢킹邱Ƃł܂B
						// WRITE_DAC|WRITE_OWNER :
						//   SetServiceObjectSecurity֐ĂяoĤ T[rX IuWFNg
						//   ZLeBLqqύXł܂B
						// 
						// GENERIC_READ :
						//   STANDARD_RIGHTS_READ SERVICE_QUERY_CONFIG SERVICE_QUERY_STATUS 
						//   SERVICE_ENUMERATE_DEPENDENTS̑gݍ킹łB
						// GENERIC_WRITE :
						//   STANDARD_RIGHTS_WRITESERVICE_CHANGE_CONFIG̑gݍ킹łB
						// GENERIC_EXECUTE :
						//   STANDARD_RIGHTS_EXECUTE SERVICE_START SERVICE_STOP 
						//   SERVICE_PAUSE_CONTINUE SERVICE_INTERROGATE 
						//   SERVICE_USER_DEFINED_CONTROL̑gݍ킹łB

	if( !hService ) {
		goto	EXIT;
	}

	bRet = QueryServiceStatus(
		hService,			// T[rX̃nh
		&status				// T[rX̃Xe[^X
	);
	if( !bRet ) {
		goto	EXIT;
	}

	bRet = FALSE;

	if( status.dwCurrentState == SERVICE_START_PENDING || status.dwCurrentState == SERVICE_STOP_PENDING ) {
		bRet = TRUE;
	}
	else if( status.dwCurrentState == SERVICE_RUNNING ) {
		bRet = TRUE;
	}

EXIT:

	// OpenSCManagerԂT[rX}l[W f[^x[X̃nhN[Y
	// OpenService֐CreateService֐ԂT[rX IuWFNg̃nhN[Y
	if( hService ) {
		CloseServiceHandle( hService );
	}
	// OpenSCManagerԂT[rX}l[W f[^x[X̃nhN[Y
	// OpenService֐CreateService֐ԂT[rX IuWFNg̃nhN[Y
	if( hSCM ) {
		CloseServiceHandle( hSCM );
	}

	return bRet;
}

